<?php

declare(strict_types=1);

namespace Drupal\cqri\HookHandler;

/**
 * Replace responsive image theme by cqri.
 */
class PreprocessCqriFormatter {

  /**
   * Replace responsive image theme by cqri.
   *
   * Default template: cqri-formatter.html.twig.
   *
   * @param array $variables
   *   An associative array containing:
   *   - item: An ImageItem object.
   *   - item_attributes: An optional associative array of HTML attributes to be
   *     placed in the img tag.
   *   - responsive_image_style_id: A responsive image style.
   *   - url: An optional \Drupal\Core\Url object.
   */
  public function preprocess(array &$variables): void {
    \template_preprocess_responsive_image_formatter($variables);

    if (isset($variables['responsive_image']['#responsive_image_style_id'])) {
      // @todo Why not just use the key responsive_image in $variables and
      // change its #theme?
      $variables['cqri_item'] = $variables['responsive_image'];
      unset($variables['responsive_image']);
      $variables['cqri_item']['#theme'] = 'cqri_item';

      $variables['#attached']['library'][] = 'cqri/cqri';
    }
  }

}
